\name{InferenceSd}
\alias{InferenceSd}
\title{
Postprocessing - Inference on the vector of state specific sd
}
\description{
This function returns the mean of the vector of state specific mean in the Monte Carlo Markov Chain iterations, after removing burn-in.
}
\usage{
InferenceSd(listSd, niter, burnin)
}
\arguments{
  \item{listSd}{
Fourth niter elements of the output of the main function
}
  \item{niter}{
Number of Monte Carlo Markov Chain iterations
}
  \item{burnin}{
Burn-in
}
}
\value{
Inferred vector of state specific sd.
}
\references{
Cassese A, Guindani M, Tadesse M, Falciani F, Vannucci M. A hierarchical Bayesian model for inference of copy number variants and their association to gene expression. Annals of Applied Statistics, 8(1), 148-175.\cr
Cassese A, Guindani M, Vannucci M. A Bayesian integrative model for genetical genomics with spatially informed variable selection. Cancer Informatics.
}
\author{
Alberto Cassese
}
\seealso{
See Also as \code{\link{Inference}}
}
\examples{
##See Inference
}
\keyword{Postprocessing}
